package net.sf.itcb.addons.monitoring.track;

import java.util.Map;

import org.springframework.aop.support.RegexpMethodPointcutAdvisor;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Required;

/**
 * Spring advisor to create monitoring interception mecanism
 * 
 * @author Pierre Le Roux
 */
public class TrackerMethodAdvisor extends RegexpMethodPointcutAdvisor implements InitializingBean {

	private static final long serialVersionUID = 1L;

	protected Map<String, String> layerPatterns;
	
	protected MonitoringTransactionManager monitoringTransactionManager;
	
	@Required
	public void setLayerPatterns(Map<String, String> layerPatterns) {
		this.layerPatterns=layerPatterns;
	}
		
	@Required
	public void setMonitoringTransactionManager(MonitoringTransactionManager monitoringTransactionManager) {
		this.monitoringTransactionManager=monitoringTransactionManager;
	}

	
	@Override
	public void afterPropertiesSet() throws Exception {
		setOrder(0);
		TrackerMethodInterceptor trackerMethodInterceptor = new TrackerMethodInterceptor();
		trackerMethodInterceptor.setMonitoringTransactionManager(monitoringTransactionManager);
		trackerMethodInterceptor.setLayerPatterns(layerPatterns);
		setAdvice(trackerMethodInterceptor);
		setPatterns(layerPatterns.values().toArray(new String[0]));
	}
	
	
	
}
