package net.sf.itcb.addons.monitoring.track.bean;

import java.util.ArrayList;
import java.util.List;

/**
 * This bean contains all information that has to be tracked
 * 
 * @author Pierre Le Roux
 */
public class ItcbTrackBean {
	
	private static final String UNDERSCORE = "_";
	
	private long startTime;
	private String user;
	private String className;
	private String method;
	private long timeInMillis;
	private long timeCpuInMillis;
	private Throwable exception;
	private String transactionId;
	private Object[] parameters;
	private String parentPhaseId;
	private ItcbTrackBean parent;
	private List<ItcbTrackBean> children;
	private String layerType;
	private int phaseId;
	private boolean trackIfNoChild=true;
	
	public Object[] getParameters() {
		return parameters;
	}

	public void setParameters(Object[] parameters) {
		this.parameters = parameters;
	}

	public long getStartTime() {
		return startTime;
	}

	public void setStartTime(long startTime) {
		this.startTime = startTime;
	}


	public long getTimeInMillis() {
		return timeInMillis;
	}

	public Throwable getException() {
		return exception;
	}

	public void setTimeInMillis(long timeInMillis) {
		this.timeInMillis = timeInMillis;
	}

	public void setException(Throwable exception) {
		this.exception = exception;
	}

	public void setTransactionId(String transactionId) {
		this.transactionId = transactionId;
	}

	public String getTransactionId() {
		return transactionId;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public String getClassName() {
		return className;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getMethod() {
		return method;
	}
	
	public void setUser(String user) {
		this.user=user;
	}
	
	public String getUser() {
		return user;
	}
	
	public long getTimeCpuInMillis() {
		return timeCpuInMillis;
	}

	public void setTimeCpuInMillis(long timeCpuInMillis) {
		this.timeCpuInMillis = timeCpuInMillis;
	}

	public String getParentPhaseId() {
		if(parentPhaseId== null) {
			return "";
		}
		return parentPhaseId;
	}

	public void setParentPhaseId(String parentPhaseId) {
		this.parentPhaseId = parentPhaseId;
	}
	public List<ItcbTrackBean> getChildren() {
		if(children == null) {
			children=new ArrayList<ItcbTrackBean>();
		}
		return children;
	}

	public void setLayerType(String layerType) {
		this.layerType = layerType;
	}
	
	public String getLayerType() {
		return layerType;
	}
	
	public int getPhaseId() {
		return phaseId;
	}
	
	public String getCompletePhaseId() {
		if(parentPhaseId!=null) {
			return parentPhaseId + UNDERSCORE + phaseId;
		}
		else {
			return String.valueOf(phaseId);
		}
	}

	public void setPhaseId(int phaseId) {
		this.phaseId = phaseId;
	}

	public ItcbTrackBean getParent() {
		return parent;
	}

	public void setParent(ItcbTrackBean parent) {
		this.parent = parent;
	}

	public boolean isTrackIfNoChild() {
		return trackIfNoChild;
	}

	public void setTrackIfNoChild(boolean trackIfNoChild) {
		this.trackIfNoChild = trackIfNoChild;
	}	
	
}
